import networkx as nx
import random

def prim(G: nx.Graph, start_node=None):
    """ Prim's Algorithm for an undirected, weighted graph, G
    Returns an MST (Minimum Spanning Tree) that contains all the nodes of G
    """

    if start_node == None:
        start_node = random.choice(list(G.nodes))

    MST = nx.Graph()

    # Create a Tree with one Node
    MST.add_node(start_node)

    while (MST.number_of_nodes() < G.number_of_nodes()):
        min_edge_weight = 9999
        min_edge = None
        #For all edges connected to MST nodes
        for (u,v,d) in G.edges.data("weight", nbunch=list(MST.nodes())):
            #BUT not having edges that cycle back!
            if v not in list(MST):
                #Identify the Minimum Weighted Edge
                if d < min_edge_weight:
                    min_edge_weight = d
                    min_edge = (u,v,d)
        MST.add_weighted_edges_from([min_edge])

    return (MST,MST.size("weight"))
